=== debian/changelog ===
zyre (1-0) UNRELEASED; urgency=low

  * Initial packaging.

 -- zyre Developers <zeromq-dev@lists.zeromq.org>  Wed, 31 Dec 2014 00:00:00 +0000
